package es.us.ccia.dummy.historial.estadof;
/**
 * Version 0.9: 
 *    20080920
 *    - Implementacion del cambio de  (DC -> EC)
 *     
 *==================================================
 * TODO: 
 *    - 
 *    
 */

import java.util.Iterator;

import es.us.ccia.contexto.Contexto;
import es.us.ccia.contexto.elementos.*;
import es.us.ccia.dummy.contexto.dialogo.ResultCambios5;
import es.us.ccia.dummy.contexto.dialogo.VentanaArreglos;
import es.us.ccia.dummy.historial.Cambio;
import es.us.ccia.rcc.RCC;
import es.us.tad.Salida;


@SuppressWarnings("unchecked")
public class DR extends Cambio {

	/**
	 * Constructor del cambio DR - EQ5
	 * @param _a Clase 1 a cambiar
	 * @param _b Clase 2 a cambiar
	 * @param _act Clase que provoca el cambio.
	 */
	public DR(FCAAttribute _a, FCAAttribute _b) {
		super(_a, _b, RCC.DR, RCC.EQ5, null);
	}

	
	public void ejecutar() {
		Salida.Imprimir("Situacion final DR");
		
		VentanaArreglos.initialize("Disconnected regions", RCC.DR,
				(FCAAttribute)getClaseA(),
				(FCAAttribute)getClaseB());
		ResultCambios5 opcion = VentanaArreglos.showDialog(null, null);
		
		
		if (opcion != null) {
			System.out.println("Operation accepted");

			// añadir todos los que pertenecen a A
			Iterator ita1 = opcion.a.iterator();
			while (ita1.hasNext()) {
				FCAObject ind = (FCAObject)ita1.next();
				Contexto.addRelation((FCAAttribute)getClaseA(), ind);
				Contexto.removeRelation((FCAAttribute)getClaseB(), ind);
			}

			// añadir todos los que pertenecen a B
			Iterator ita2 = opcion.b.iterator();
			while (ita2.hasNext()) {
				FCAObject ind = (FCAObject)ita2.next();
				Contexto.addRelation((FCAAttribute)getClaseB(), ind);
				Contexto.removeRelation((FCAAttribute)getClaseA(), ind);
			}
			
		} else {
		
			System.out.println("Operation cancelled");
		}

	}

}
