package es.us.ccia.dummy.historial.estadof;
/**
 * Version 0.9: 
 *    20080920
 *    - Implementacion del cambio de  (DC -> EC)
 *     
 *==================================================
 * TODO: 
 *    - 
 *    
 */

import java.util.*;

import es.us.ccia.contexto.Contexto;
import es.us.ccia.contexto.elementos.*;
import es.us.ccia.dummy.contexto.dialogo.ResultCambios5;
import es.us.ccia.dummy.contexto.dialogo.VentanaArreglos;
import es.us.ccia.dummy.historial.Cambio;
import es.us.ccia.rcc.RCC;
import es.us.tad.Salida;


@SuppressWarnings("unchecked")
public class PP extends Cambio {

	public PP(FCAAttribute _a, FCAAttribute _b) {
		super(_a, _b, RCC.DR, RCC.PP,null);
	}

	
	public void ejecutar() {
		Salida.Imprimirln("Final situation: PP ");
		
		/*****
		 * 1. Añadir todo lo de A en B...
		 */
		Collection a  = Contexto.get_ObjetosClase((FCAAttribute)getClaseA());
		Iterator it3 = a.iterator();
		while (it3.hasNext()) {
			FCAObject indiv = (FCAObject)it3.next();
			Contexto.addRelation(indiv.getNombre(), getClaseB().getNombre());
		}
	
		
		
		/*****
		 * 2. Comprobar que hay un elemento en B que no lo hay en A
		 *     
		 */
		Collection b2 = Contexto.get_ObjetosClase((FCAAttribute)getClaseB());
		b2.removeAll(a);
		
		if (b2.size()>0) {
			// Caso correcto
		} else {
			VentanaArreglos.initialize("Proper Part Regions",RCC.PP,
					(FCAAttribute)getClaseA(),
					(FCAAttribute)getClaseB());
			ResultCambios5 opcion = VentanaArreglos.showDialog(null,null);

			if (opcion != null) {

				// añadir todos los que pertenecen a A
				Iterator ita1 = opcion.a.iterator();
				while (ita1.hasNext()) {
					FCAObject ind = (FCAObject)ita1.next();
					Contexto.addRelation((FCAAttribute)getClaseA(), ind);
					Contexto.removeRelation((FCAAttribute)getClaseB(), ind);
				}

				// añadir todos los que pertenecen a B
				Iterator ita2 = opcion.b.iterator();
				while (ita2.hasNext()) {
					FCAObject ind = (FCAObject)ita2.next();
					Contexto.addRelation((FCAAttribute)getClaseB(), ind);
					Contexto.removeRelation((FCAAttribute)getClaseA(), ind);
				}

				// añadir todos los que pertenecen a A y B
				Iterator ita3 = opcion.interseccion.iterator();
				while (ita3.hasNext()) {
					FCAObject ind = (FCAObject)ita3.next();
					Contexto.addRelation((FCAAttribute)getClaseB(), ind);
					Contexto.addRelation((FCAAttribute)getClaseA(), ind);
				}
			}

		}
		
		
		
		
		
	}

}
