package es.us.ccia.dummy.historial;
/**
 * Version 0.9: 
 *    20080920
 *    - Creacion de una clase abstracta para llamar 
 *      a cualquiera de los cambios
 *     
 *==================================================
 * TODO: 
 *    - 
 *    
 */


import es.us.ccia.contexto.elementos.FCAElement;
import es.us.ccia.rcc.RCC;


public abstract class Cambio implements I_Cambio {

	private FCAElement ClaseA;
	private FCAElement ClaseB;
	private int    tipoviejo;
	private int    tiponuevo;
	private FCAElement Activo;
	
	
	
	public Cambio(FCAElement _a, FCAElement _b, 
			int _tipoV, int _tipoN,
			FCAElement _act) {
		this.ClaseA = _a;
		this.ClaseB = _b;
		this.tipoviejo = _tipoV;
		this.tiponuevo = _tipoN;		
		this.Activo = _act;
	}



	/* (non-Javadoc)
	 * @see es.us.ccia.paella.historial.I_Cambios#getClaseA()
	 */
	public FCAElement getClaseA() {
		return ClaseA;
	}


	/* (non-Javadoc)
	 * @see es.us.ccia.paella.historial.I_Cambios#getClaseB()
	 */
	public FCAElement getClaseB() {
		return ClaseB;
	}



	/* (non-Javadoc)
	 * @see es.us.ccia.paella.historial.I_Cambios#getTipoviejo()
	 */
	public int getTipoviejo() {
		return tipoviejo;
	}



	/* (non-Javadoc)
	 * @see es.us.ccia.paella.historial.I_Cambios#getTiponuevo()
	 */
	public int getTiponuevo() {
		return tiponuevo;
	}

	/* (non-Javadoc)
	 * @see es.us.ccia.paella.historial.I_Cambios#getTiponuevo()
	 */
	public FCAElement getActivo() {
		return this.Activo;
	}


	@Override
	public String toString() {
		String devolver  = new String(
				"(" + getClaseA().getNombre() + ", " + getClaseB().getNombre() + ")  " + 
				RCC.toString(tipoviejo) +  "-->" + 
				RCC.toString(tiponuevo));
		devolver += " *" + Activo.getNombre() + "*";
		return devolver;
	}
	
	
	/* (non-Javadoc)
	 * @see es.us.ccia.paella.historial.I_Cambios#ejecutar()
	 */
	public abstract void ejecutar();
	
	
	
	
	
	
	
	
	
}
