package es.us.ccia.dummy.historial.estadof;
/**
 * Version 0.9: 
 *    20080920
 *    - Implementacion del cambio de  (DC -> EC)
 *     
 *==================================================
 * TODO: 
 *    - 
 *    
 */


import java.util.*;

import javax.swing.JOptionPane;

import es.us.ccia.contexto.Contexto;
import es.us.ccia.contexto.elementos.FCAAttribute;
import es.us.ccia.contexto.elementos.FCAObject;
import es.us.ccia.dummy.contexto.dialogo.NuevaClase;
import es.us.ccia.dummy.contexto.dialogo.ResultCambios5;
import es.us.ccia.dummy.contexto.dialogo.VentanaArreglos;
import es.us.ccia.dummy.historial.Cambio;
import es.us.ccia.rcc.RCC;

@SuppressWarnings("unchecked")
public class PO5 extends Cambio {
	/*******
	 * 
	 * Cambio de DR -> PO5
	 * 
	 * 1. Se eligen los elementos que pertenecen a la interseccion
	 * 
	 */

	public PO5(FCAAttribute _a, FCAAttribute _b) {
		super(_a, _b, RCC.DR, RCC.PO5,null);
	}

	
	public void ejecutar() {
		
		VentanaArreglos.initialize("Partial Overlapped Regions",RCC.PO5,
				(FCAAttribute)getClaseA(),
				(FCAAttribute)getClaseB());
		ResultCambios5 opcion = VentanaArreglos.showDialog(null,null);

		if (opcion != null) {

			// añadir todos los que pertenecen a A
			Iterator ita1 = opcion.a.iterator();
			while (ita1.hasNext()) {
				FCAObject ind = (FCAObject)ita1.next();
				Contexto.addRelation((FCAAttribute)getClaseA(), ind);
				Contexto.removeRelation((FCAAttribute)getClaseB(), ind);
			}

			// añadir todos los que pertenecen a B
			Iterator ita2 = opcion.b.iterator();
			while (ita2.hasNext()) {
				FCAObject ind = (FCAObject)ita2.next();
				Contexto.addRelation((FCAAttribute)getClaseB(), ind);
				Contexto.removeRelation((FCAAttribute)getClaseA(), ind);
			}

			// añadir todos los que pertenecen a A y B
			Iterator ita3 = opcion.interseccion.iterator();
			while (ita3.hasNext()) {
				FCAObject ind = (FCAObject)ita3.next();
				Contexto.addRelation((FCAAttribute)getClaseB(), ind);
				Contexto.addRelation((FCAAttribute)getClaseA(), ind);
			}

			int nueva = JOptionPane.showConfirmDialog(null,
					"Wish you create a tag for some(or all) elements in intersection.",
					"Create",
					JOptionPane.YES_NO_OPTION
			);

			if (nueva == JOptionPane.YES_OPTION) {
				
				System.out.println("Esto es que si");
				
				NuevaClase.initialize(null,opcion.interseccion.toArray(),"");
				NuevaClase.showDialog(null,null);

				
				
				
			} else {
				
				
				System.out.println("Esto es que NOOoo");
				
				
				
			}
		
		
		
		
		
		
		} else {
			System.out.println("the user cancelled the operation.");			
		}
				
		
		
		/***
		
		
//		GUI g = DummyPaella.getGUI();		
//		
		////////////////////////////////////
		//   CREAR CLASE
		////////////////////////////////////

		Collection names = new LinkedList();
		names.addAll(Contexto.get_ObjetosClase((FCAAttribute)getClaseA()));
		names.addAll(Contexto.get_ObjetosClase((FCAAttribute)getClaseB()));

		////////////////////////////////////////////////////////
		// Elegir los objetos de A y B que van a pertenecer a la 
		// interseccion.
		////////////////////////////////////////////////////////
		
		
		ElegirIndividuos.initialize(null, names.toArray(), "mi casa");
		ArrayList opcion = ElegirIndividuos.showDialog(null, null);
		
		// Si los eliges todos, es que piensas, en el fondo, que ambas
		// etiquetas son iguales.
		
		Iterator it = opcion.iterator();
		Salida.Imprimirln("Choosen individuals: ");
		while (it.hasNext()) {
			FCAObject ind = (FCAObject)it.next();
			Salida.Imprimirln(ind.getNombre());
			Contexto.addRelation((FCAAttribute)getClaseA(), ind);
			Contexto.addRelation((FCAAttribute)getClaseB(), ind);
		}

		
		// ASEGURAR QUE EL RESULTADO ES PO!!!!!
		
		/*
		 * Si despuees de elegir, hay que ver si quedan cosas en A  
		 * que no estan een B... y reciprocamente.
		 * 
		 * HACER EN TODAS 
		 * 
		 */
		
		
		
		
	   // Anadir si quiere uno nuevo y lo de las etiquetas aconsejadas.
	
	}

}
